//Giulia Giacalone

#define BOUND 4

int coprimes[2];

//compute gcd
int gcd(int a,int b) {
	int c;
    while(1) {
  		c = a%b;
  		if(c==0) {
  			return b;
  		}
  		a = b;
  		b = c;
    }
}

//coprime number gcd=1
int coprime(int a) {
	int i;
	int x = a;
  for(i = x; i >= 1; i--){
    if( gcd(i, x) == 1) {
    	coprimes[0] = x;
    	coprimes[1] = i;
    	return 1;
    } 
  }
  return 0;
}

int is_coprime(int a, int b) {
	 if( gcd(a,b) == 1) {
	 	return 1;
	 }
	 return 0;
}

int nondet_int();

int generate_number() {
  	int rn;
  	rn = nondet_int();
  	__CPROVER_assume (rn <= BOUND);
  	__CPROVER_assume (rn > 1);
  	return rn;
}

//totient
int totient(int a) {
	int t=0;
	int i;
  	for (i=1;i<=a;i++) {
     	if(gcd(i,a) == 1) { 
           	t++;
      	}
  	}  
  	return t;
}

int myPow(int x, int y) {
	if (x==0) { return 0; } 
	if (y==0||x==1) { return 1; } 
	if (y==1) { return x; }
	int i;
	int myPow=x;
	for(i=1; i<y; i++) {
		 myPow=myPow*x;
	}
	return myPow;
}

//euler
int euler(int a, int n) {
	return myPow(a,(totient(n)))%n;
}

void main(void) {
	int a, result, coprimeNumbers;
  	a=generate_number();
  	coprimeNumbers=coprime(a);
  	//assert that coprimes does not fail
  	assert(coprimeNumbers==1);
  	//the two numbers have to be coprimes
  	assert(is_coprime(coprimes[0],coprimes[1]));
  	//assert that totient exists
  	//assert(totient(coprimes[0])>0);
  	//assert(totient(coprimes[1])>0);
  	//totient: if two numbers m and n are relative primes totient(mn) = totient(m)totient(n)
  	//assert(totient(coprimes[0])*totient(coprimes[1]) == totient(coprimes[0]*coprimes[1]));
  	//coprimes must be positive integers
  	assert(coprimes[0] > 0);
  	assert(coprimes[1] > 0);
  	//result = euler(coprimes[1],coprimes[0]);
  	//euler must be one
  	//assert(result == 1);
}
